//: c14:SimpleThread.java
// Very simple Threading example.
 
public class SimpleThread extends Thread {
  private int countDown = 5;
  private static int threadCount = 0;
  private int threadNumber = ++threadCount;
  public SimpleThread(Thread t) {
    System.out.println("Making " + threadNumber);
    if(t!=null)
    	try {
    		t.join();
    	} catch(InterruptedException e){
      	  System.out.println("Thread " + threadNumber + " interrupted..........");
        }
    start();
  }
  public void run() {
    while(true) {
      System.out.println("Thread " + threadNumber + "(" + countDown + ")");
      if(--countDown == 0) return;
      // yield();
      try {
    	  sleep(100);
      } catch(InterruptedException e){
    	  System.out.println("Thread " + threadNumber + " interrupted..........");
      }
    }
  }
  public static void main(String[] args) {
    Thread t = null;
	for(int i = 0; i < 5; i++)
       t = new SimpleThread(t);
    
	//t.interrupt();
	System.out.println("All Threads Started");
  }
} ///:~
 
